package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.ConfRestricaoCanalVenta;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.ConfRestricaoCanalVentaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.MyComboRutaRenderer;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConfRestricaoCanalVenta;

@Controller("confRestricaoCanalVentaController")
@Scope("prototype")
public class BusquedaConfRestricaoCanalVentaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;	
	@Autowired
	private TipoPuntoVentaService tipoPtoVtaService;
	@Autowired
	private transient PagedListWrapper<ConfRestricaoCanalVenta> plwConfRestricaoCanalVenta;
	private MyListbox confRestricaoCanalVentaList;
	private Paging pagingConfRestricaoCanalVenta;
	private List<TipoPuntoVenta> lsTipoPtoVta;
	private Datebox dtServicio;
	private Datebox feciniciovigencia;
	private Datebox fecfinvigencia;
	private Combobox cmbRuta;
	private Combobox cmbOrigen;
	private Combobox cmbDestino;
	private Combobox cmbEmpresa;
	private Combobox cmbTipoPtoVta;
	private MyComboboxPuntoVenta cmbPtoVta;
	private Textbox txtDescConf;
	private Intbox txtServico;
	private List<Empresa> lsEmpresa;
	private Intbox txtIdBloqueio;	
	private Set<ConfRestricaoCanalVenta> selected;
	@Autowired
	private ConfRestricaoCanalVentaService confRestricaoCanalVentaService;
	
	public Set<ConfRestricaoCanalVenta> getSelected() {
		return selected;
	}

	public void setSelected(Set<ConfRestricaoCanalVenta> selected) {
		this.selected = selected;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public List<TipoPuntoVenta> getLsTipoPtoVta() {
		return lsTipoPtoVta;
	}

	public void setLsTipoPtoVta(List<TipoPuntoVenta> lsTipoPtoVta) {
		this.lsTipoPtoVta = lsTipoPtoVta;
	}


	@Override
	public void doAfterCompose(Component comp) throws Exception {		
		lsEmpresa = UsuarioLogado.getUsuarioLogado().getEmpresa();
		selected = new HashSet<ConfRestricaoCanalVenta>();
		lsTipoPtoVta = tipoPtoVtaService.obtenerTodos();
		super.doAfterCompose(comp);
		cmbRuta.setItemRenderer(new MyComboRutaRenderer());
		
		confRestricaoCanalVentaList.setItemRenderer(new RenderConfRestricaoCanalVenta(confRestricaoCanalVentaList, this));
		
		refreshLista();
	}

	private void refreshLista() {
		HibernateSearchObject<ConfRestricaoCanalVenta> confRestricaoCanalVentaBusqueda =
				new HibernateSearchObject<ConfRestricaoCanalVenta>(ConfRestricaoCanalVenta.class,
						pagingConfRestricaoCanalVenta.getPageSize());

		String desc = txtDescConf.getValue();
		if (!desc.isEmpty()) {
			confRestricaoCanalVentaBusqueda.addFilterLike("descConfRestricaoCanalVenta", desc + "%");
		}

		Integer servicio = txtServico.getValue();
		if (servicio != null) {
			confRestricaoCanalVentaBusqueda.addFilterEqual("corridaId", servicio);
		}
		
		Integer idBloqueio = txtIdBloqueio.getValue();
		if (idBloqueio != null) {
			confRestricaoCanalVentaBusqueda.addFilterEqual("confRestricaoCanalVentaId", idBloqueio);
		}

		Comboitem cbiRuta = cmbRuta.getSelectedItem();
		if (cbiRuta != null) {
			Ruta ruta = (Ruta) cbiRuta.getValue();
			confRestricaoCanalVentaBusqueda.addFilterEqual("ruta", ruta);
		}
		
		Comboitem cbiOrigem = cmbOrigen.getSelectedItem();
		if (cbiOrigem != null) {
			Parada origem = (Parada) cbiOrigem.getValue();
			confRestricaoCanalVentaBusqueda.addFilterEqual("lsConfRestricaoTramo.origem", origem);
		}

		Comboitem cbiDestino = cmbDestino.getSelectedItem();
		if (cbiDestino != null) {
			Parada destino = (Parada) cbiDestino.getValue();
			confRestricaoCanalVentaBusqueda.addFilterEqual("lsConfRestricaoTramo.destino", destino);
		}
		
		
		Comboitem cmibTipoPtoVta = cmbTipoPtoVta.getSelectedItem();
		if (cmibTipoPtoVta != null) {
			TipoPuntoVenta tipoPuntoVenta = (TipoPuntoVenta) cmibTipoPtoVta.getValue();
			confRestricaoCanalVentaBusqueda.addFilterEqual("lsConfRestricaoTramo.tipoPuntoVenta", tipoPuntoVenta);
		}
		
		Comboitem cmiPtoVta = cmbPtoVta.getSelectedItem();
		if (cmiPtoVta != null) {
			PuntoVenta puntoVenta = (PuntoVenta) cmiPtoVta.getValue();
			confRestricaoCanalVentaBusqueda.addFilterEqual("lsConfRestricaoPtovta.puntoVenta", puntoVenta);
		}
		
		Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
		if(cbiEmpresa != null){
			Empresa empresa = (Empresa) cbiEmpresa.getValue();
			confRestricaoCanalVentaBusqueda.addFilterEqual("empresa", empresa);
		}
		
		Date dataServico = dtServicio.getValue();
		if(dataServico!= null) {
			confRestricaoCanalVentaBusqueda.addFilterEqual("fecCorrida", dataServico);
		}
		
		if (feciniciovigencia.getValue() != null) {
			Calendar dataInicioVigencia = Calendar.getInstance();
			dataInicioVigencia.setTime(DateUtil.inicioFecha(feciniciovigencia.getValue()));
			confRestricaoCanalVentaBusqueda.addFilterGreaterOrEqual("feciniciovigencia", dataInicioVigencia.getTime());
		}
		
		if (fecfinvigencia.getValue() != null) {
			Calendar dataFimVigencia = Calendar.getInstance();
			dataFimVigencia.setTime(DateUtil.fimFecha(fecfinvigencia.getValue()));
			confRestricaoCanalVentaBusqueda.addFilterLessOrEqual("fecfinvigencia", dataFimVigencia.getTime());
		}

		confRestricaoCanalVentaBusqueda.addFilterEqual("activo", Boolean.TRUE);
		confRestricaoCanalVentaBusqueda.setDistinct(true);

		plwConfRestricaoCanalVenta.init(confRestricaoCanalVentaBusqueda, confRestricaoCanalVentaList,
				pagingConfRestricaoCanalVenta);

		if (confRestricaoCanalVentaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaCiudadController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
		
		selected.clear();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verConfRestricaoCanalVenta(ConfRestricaoCanalVenta conf) {
		if (conf == null) {
			return;
		}

		Map args = new HashMap();
		args.put("confRestricaoCanalVenta", conf);
		args.put("confRestricaoCanalVentaList", confRestricaoCanalVentaList);

		openWindow("/gui/esquema_operacional/editarConfRestricaoCanalVenta.zul",
				Labels.getLabel("editarConfRestricaoCanalVentaController.window.title"),
				args, MODAL);
	}
	
	public void onSelect$confRestricaoCanalVentaList() {
		int pos = 0;
		for (Object o : confRestricaoCanalVentaList.getData()) {
			ConfRestricaoCanalVenta e = (ConfRestricaoCanalVenta) o;
			if (confRestricaoCanalVentaList.getItemAtIndex(pos).isSelected()) {
				if (!selected.contains(e)) {
					selected.add(e);
				}
			} else {
				selected.remove(e);
			}
			pos++;
		}
	}

	public void onAfterRender$confRestricaoCanalVentaList() {
		if (confRestricaoCanalVentaList.getData() != null) {
			int pos = 0;
			for (Object o : confRestricaoCanalVentaList.getData()) {
				ConfRestricaoCanalVenta e = (ConfRestricaoCanalVenta) o;
				if (selected.contains(e)) {
					confRestricaoCanalVentaList.addItemToSelection(confRestricaoCanalVentaList.getItemAtIndex(pos));
				}
				pos++;
			}
		}
	}
	

	public void onClick$btnApagar(Event ev) throws InterruptedException {
		
		if(selected.isEmpty()) {
			Messagebox.show(
					Labels.getLabel("confRestricaoCanalVentaController.MSG.semRestricaoSelecionados"),
					Labels.getLabel("confRestricaoCanalVentaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}
		
		Integer resp = Messagebox.show(
				Labels.getLabel("confRestricaoCanalVentaController.MSG.borrarPergunta"),
				Labels.getLabel("confRestricaoCanalVentaController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp.equals(Messagebox.YES)) {
			confRestricaoCanalVentaService.borrarList(selected);

			Messagebox.show(
					Labels.getLabel("editarConfRestricaoCanalVentaController.MSG.borrarOK"),
					Labels.getLabel("editarConfRestricaoCanalVentaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

		  refreshLista();
		
		}
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verConfRestricaoCanalVenta(new ConfRestricaoCanalVenta());
	}
	
}
